' Jasc Soccer Just Another Sensi Clone - a try to make a sensi clone by Pitto

'TODO LIST ##############################################################################
' MATCH EVENTS
' HEADKICKS routine
' draw other sprites
' cleanup code (heavy work!) <-------- :(
' better ball physics
' pl acceleration delta - not immediately can reach top speed
' IMPROVE AI (sooo much!)
' improve the "get_passing_ball_speed" function
' matchtime and half-time field switch
' Human vs Pc
' replay
' change team color by pset function
' FPS limit
' custom font
' dedicated AI for the GK - jump, hold the ball
' GAME MENU
'########################################################################################

' a must
#include "fbgfx.bi"

'this is the language I use
Using FB

'oh yea, I like random numbers, They're so useful and funny! :)
randomize timer()

#define GAME_NAME "JASC SOCCER"
#define GAME_VERSION "0.18"
#define GAME_AUTHOR "Pitto"

'pitch dimensions - no change x and y, please, or the gk may get crazy :O
#define PITCH_X 50 
#define PITCH_Y 50
'***PLEASE, use a 32 multiplier, so the pitch texture may fit better! :)
#define PITCH_W 1024
#define PITCH_H 480
#define PITCH_PENALTY_AREA PITCH_H*0.30
#define PITCH_NET_W 100
#define PITCH_NET_H 25

#define PITCH_MIDDLE_W PITCH_W/2 + PITCH_X
#define PITCH_MIDDLE_H PITCH_H/2 + PITCH_Y

'net positions
#define PITCH_NET_RX_CENTER PITCH_W+PITCH_X
#define PITCH_NET_RY_CENTER PITCH_H/2+PITCH_Y
#define PITCH_NET_LX_CENTER PITCH_X
#define PITCH_NET_LY_CENTER PITCH_H/2+PITCH_Y

'tiles on the pitch *NO CHANGE THIS VALUE PLEASE!*** JASC MAY CRASH :(
#define TILES_N_TOT 35
#define COL_TOT_N 6
#define ROW_TOT_N 6

'players for each team *SAME AS ABOVE* :(
#define N_TOT_PL 11

'gravity acceleration
#define GRAVITY_ACCEL 9.8
'friction of the ball bouncing on the pitch
#define BOUNCE_FRICTION 0.85
'friction of the air
#define AIR_FRICTION 0.98
'friction of the pitch
#define FRICTION 0.90
'default speed of the players
#define PL_DEFAULT_SPEED 1.3
'screen width and height
#define SCREEN_W 400
#define SCREEN_H 300
'useful to don't allow the camera to move everywere, this sets a limit
#define CAMERA_PADDING 45
'maximum speed the ball can reach so it doesn't become a ball flame
#define BALL_MAX_SPEED 20

'minimum speed of the ball
#define BALL_MIN_SPEED 0.5

'delay of the player before executing another action
#define PL_DELAY_TIME 50

#define PL_DELAY_FALLING 10
#define PL_DELAY_FALLED 20
'minimum distance between two players - see check_pl_collisions sub for details
#define PL_MIN_DIST 10
'minimum distance from opponent pl to allow pl owner of the ball to run to the net
#define PL_RUN_SPACE 80

'lenght in ms of the sleep statement
#define SLEEP_TIME 25

'colors
#define COLOR_BLACK &h000000
#define COLOR_WHITE &hFFFFFF
#define COLOR_GRAY &h7F7F7F
#define COLOR_RED &hFF0000
#define COLOR_BLUE &h0000FF
#define COLOR_GREEN &h00FF00
#define COLOR_YELLOW &hFFFF00
#define COLOR_CYAN &h00FFFF
#define COLOR_LILIAC &h7F00FFs
#define COLOR_ORANGE &hFF7F00
#define COLOR_PURPLE &h7F007F
#define COLOR_DARK_RED &h7F0000
#define COLOR_DARK_GREEN &h007F00
#define COLOR_DARK_BLUE &h00007F

'kit predefined colors
#define COLOR_KIT_HAIR RGB(23,23,23)
#define COLOR_KIT_SHIRT RGB(0,0,127)
#define COLOR_KIT_PANTS RGB(127,127,255)
#define COLOR_KIT_SHOES RGB(63,63,63)
#define COLOR_KIT_LINE RGB(43,154,209)
#define COLOR_KIT_SKIN RGB(255,125,20)

'total number of the player sprites
#define PL_SPRITES_TOT_N 112

'CONSTS----------------------------------------------------------------------------------
const PI as single = 3.14159
const PI8 as single = 0.78539
const GRAVITY as single = 0.98

'TYPES
TYPE camera_proto
    dim x as single
    dim y as single
    dim w as single
    dim h as single
    dim speed as single
    dim rds as single
END TYPE

TYPE player_proto
    dim id as Ubyte       'unique id of the player 0-N_TOT_PL*2
    dim team as Ubyte     ' 0  for home team - 1 for away team
    dim number as Ubyte   'number of the player
    dim label as string * 32 'name of the player    *out of order
    dim old_x as single 'old x position
    dim old_y as single 'old y position
    dim x as single         'x position
    dim y as single         'y position
    dim z as single         'z position
    dim rds as single       'rotation of the player (in radiants (0-6.28))
    dim tact_offset_x as byte 'offset x to the tactic
    dim tact_offset_y as byte 'offset y to the tactic
    dim speed_default as single     'speed defualt of the player
    dim speed as single     'speed of the player
    dim speed_max as single 'maximum speed that the player can reach
    dim accel as single     'acceleration delta    *out of order
    dim frame as Ubyte    'useful to get the correct sprite frame
    dim frame_offset as Ubyte 'useful to get the correct sprite frame
    dim dist as single  'distance covered by the pl
    dim w as Ubyte        'width
    dim ball_radius as Ubyte 'maximum distance to get the ball    *out of order
    dim active as Ubyte ' check if the player is ready to make an action
    'ACTION: 0 none; 1 Running; 2 Jumping; 3 Sliding; 4 Falling; 5 Falled
    dim action as Ubyte 
    dim delay as Ubyte ' how many cycles delays the player to perform  an action
END TYPE

TYPE ball_proto
    dim x as single         'x position
    dim y as single         'y position
    dim z as single         'z position
    dim old_x as single
    dim old_y as single
    dim z_speed as single       'z accel ratio
    dim z_speed_init as single   'z accel ratio
    dim speed as single     'speed 
    dim w as Ubyte  'width
    dim rds as single 'rotation
    dim effect as single 'effect
    dim frame as Ubyte 'which frame
END TYPE

'SHARED VARIABLES----------------------------------------------------------------------------
DIM SHARED DEBUG as Ubyte = 0

DIM SHARED goal_team_0 as integer = 0
DIM SHARED goal_team_1 as integer = 0

dim shared tct_tile(0 to 9, 0 to 35) as Byte 'tactic array
'it indicates in wich `a` tile the pl must go if the ball is in `b` tile
'for example: ball in tile 20, pl must go to tile 12
'see also functions `get_tact_tile`, `get_rds_from_tile`,
'`get_dist_from_tile` and `get_ball_tile`
'and sub `load_tact`

dim shared bhv_tile(0 to 35, 0 to 9) as Byte 'behavior array
'it gives a percentage table for the behavior of the players owners of the ball
'see relative sub for details

dim shared pl_sprites_action(0 to 5, 0 to 1) AS Ubyte 'sprites for pl.action

'it represents (action, (Lbound of sprites, Ubound of sprites))Lbound & Ubound of the sprites
DIM SHARED pl_sprite_0(PL_SPRITES_TOT_N) AS ANY PTR ' A pointer that points to a memory buffer (for plrs sprites)
DIM SHARED pl_sprite_1(PL_SPRITES_TOT_N) AS ANY PTR ' A pointer that points to a memory buffer (for plrs sprites)
DIM SHARED ball_sprite(15) AS ANY PTR '  A pointer that points to a memory buffer (for ball sprites)
DIM SHARED net_sprite(2) AS ANY PTR '  A pointer that points to a memory buffer (for net sprites)
DIM SHARED pitch_sprite(2) AS ANY PTR '  A pointer that points to a memory buffer (for pitch sprites)
DIM SHARED banner_sprite AS ANY PTR 'idem for banner
DIM SHARED shadowed_sprite AS ANY PTR 'idem for shadowed sprite

DIM SHARED workpage AS INTEGER ' buffer holding the player sprites
DIM SHARED addframe as Ubyte = 0 'to be soon removed

DIM shared c_x_o as single = 0 'camera x offset
DIM shared c_y_o as single = 0 'camera y offset

dim shared camera as camera_proto 'camera type
dim shared pl(N_TOT_PL*2) as player_proto 'player type
dim shared ball as ball_proto 'ball type

dim shared PL_target_id as Byte = -1 '-1: none; 0-etc. indicates the id of the pl that's receiving pass
dim shared PL_ball_owner_id as Byte = -1 '-1: none; 0-etc. indicates the id of the pl owning the ball
dim shared PL_ball_owner_delay as UByte = PL_DELAY_TIME*2 'for how much time owning the ball after the touch
dim shared PL_team_owner_id as Byte = -1 'indicates the id of the team owning the ball

dim shared SHELL_message as string * 64 'this is useful for debug, to store and display shell-like messages

dim shared MATCH_event as Byte = -1 'indicates the actual match event
' -1 none; 0   ; 1 in action; 2 ball off upper side; 3 ball off lower side
' 4 ball off left side; 5 ball off right side; 6 freekick; 7 penalty


'USEFUL VARIABLES----------------------------------------------------------------------------
dim count as integer = 0

'init camera dimensions
camera.w = SCREEN_W
camera.h = SCREEN_H
camera.x = PITCH_MIDDLE_W
camera.y = PITCH_MIDDLE_H

' FUNCTIONS DECLARATIONS---------------------------------------------------------------------
'converts radiants to degree
declare function r_t_d (degree as integer) as integer
' converts degree to radiants
declare function d_t_r (degree as integer) as single
' calculates the angle between two points
declare function a_b_t_p (x1 as single, y1 as single, x2 as single, y2 as single) as single
' calculates the distance between two points
declare function d_b_t_p (x1 as single, y1 as single, x2 as single, y2 as single) as single
' calculates the starting frame for the player sprite from the angle in radiants
declare function start_frame (radiants as single) as integer
' calculates in wich pitch tile the player must go (use it if the player hasn't the ball possession)
declare function get_tact_tile (pl_id as Ubyte) as Ubyte
' returns in wich tile is the ball
declare function get_ball_tile(team as Ubyte) as Ubyte
' calculate the radiants to get the right tile
declare function get_rds_from_tile(tile as Ubyte, pl_x as single, pl_y as single) as single
' calculate the distance between player and the tile where he must go
declare function get_dist_from_tile(tile as Ubyte, pl_x as single, pl_y as single) as single
' return the nearest player to the ball
declare function get_nrst_pl_ball(n_team as Ubyte) as Ubyte
' giving the id of the team returns the nearest player to pass the ball
declare function get_nrst_pl_pass(pl_id as Ubyte) as Ubyte
' giving the id of the team returns the 2nd nearest player to pass the ball
declare function get_nrst2_pl_pass(pl_id as Ubyte, order as Ubyte) as Ubyte
' giving the unique id of the player calculate wich is his team
' and return the farrest player to pass the ball
declare function get_farrest_pl_to_pass(pl_id as Ubyte) as Ubyte    '*out of order
' giving the unique id of the player calculate wich is his team and
'return the player nearest to the corner line
declare function get_endline_pl_to_pass(pl_id as integer) as Ubyte
' giving the unique id of the player calculate wich is his team and
'return the player nearest to middlefield
declare function get_centerest_pl_to_pass(pl_id as Ubyte) as Ubyte
' giving the unique id of the player owner of the ball
' calculate wich is his team and returns the right player to pass by longside 
declare function get_longside_pl_to_pass (pl_id as Ubyte) as Ubyte
' giving the unique id of the player owner of the ball
' calculate wich is his team and returns the right player to pass by shortside
declare function get_shortside_pl_to_pass (pl_id as Ubyte) as Ubyte
'giving the distance between pl an pl to pass returns the correct speed of the ball
declare function get_passing_ball_speed (dist as Single) as Single
'this function returns 1 if the object is into the camera crop - useful to use less CPU timing for
'drawing functions
declare function is_in_camera_crop (x as single, y as single, diam as integer) as Ubyte


'SUBS DECLARATIONS-----------------------------------------------------------------------
'load fonts
DECLARE SUB load_fonts()
'load tactics
DECLARE SUB load_tact()
'load behavior of the player owner of the ball
DECLARE SUB load_behavior()
'gest keyboard events
DECLARE SUB get_user_input()
'load sprites
DECLARE SUB load_bitmap()
'paints the kits of the teams with a custom color
DECLARE SUB paint_kits(color_shirt_0 as Uinteger, color_pants_0 as Uinteger,_
color_shirt_1 as Uinteger, color_pants_1 as Uinteger)
'delete the sprites
DECLARE SUB delete_bitmap()
'draws the nets
DECLARE SUB draw_nets()
'draws the pitch
DECLARE SUB draw_pitch()
'update the ball
DECLARE SUB update_ball()
'draw the grid
DECLARE SUB draw_grid()
'draws the players
DECLARE SUB draw_players()
'resets the position of the players (0's ids on the left side, 1's ids on the right side)
DECLARE SUB reset_players_positions()
'puts the ball into the centre of the pitch
DECLARE SUB ball_put_on_centre()
' update the beahovior of the players
DECLARE SUB update_players()
' checks if the ball gest the limits of the pitch
' or if the ball goes into any net
DECLARE SUB ball_border_pitch_limit_check()
'updates the position of the camera following the ball with easing effect
DECLARE SUB camera_update_position()
'initialize the players proprietes
DECLARE SUB init_players_proprietes()
'sets to 0 axis z of the ball and z_Speed of the ball
DECLARE SUB reset_ball_z()
'draws the ball
DECLARE SUB draw_ball()
'giving the id of the player who owns the ball, calculate in wich tile is,
'it manages the player behavior (for example: running to the net, passing, shooting, etc...)
DECLARE SUB get_pl_behavior(pl_id as Ubyte)
'cheks if two or more players collide
DECLARE SUB check_pl_collisions()
'draws the bottom infos
DECLARE SUB draw_bottom_info()

SUB load_fonts()
'    draw string
END SUB


SUB load_bitmap()
    dim img_x as integer
    dim img_w as integer
    dim img_y as integer
    dim img_h as integer
    dim count as Ubyte
    dim action as Ubyte
    
    'initializing pl_sprites_action array - see definition fot details
'    For action = 0 To 2
'        Read pl_sprites_action(action, 0)
'        Read pl_sprites_action(action, 1)
'    Next action
    
    'loading pl sprites
    img_w = 21
    img_h = 25
    img_x = 0
    img_y = 0
    'load and stores the sprites into two array
    'one array for each team then with paint_kits sub
    'the color of the kits of the sprites will be changed
    BLOAD "img\pl_sprites.bmp", 0
    for count = 0 to PL_SPRITES_TOT_N-1
        if (count > 0) and (count MOD 14 = 0) then
            img_x = 0
            img_y += img_h
        end if
        pl_sprite_0(count) = IMAGECREATE (img_w, img_h)
        pl_sprite_1(count) = IMAGECREATE (img_w, img_h)
        GET (img_x, img_y)-(img_x + 20, img_y + 24), pl_sprite_0(count)
        GET (img_x, img_y)-(img_x + 20, img_y + 24), pl_sprite_1(count)
        img_x += img_w
    next count
    
    'loading ball sprites
    BLOAD "img\ball_sprites.bmp", 0
    img_x = 0
    img_y = 0
    for count = 0 to 14
        ball_sprite(count) = IMAGECREATE (img_w, img_h)
        GET (img_x, img_y)-(img_x + 15, img_y + 15), ball_sprite(count)
        img_x += 16
    next count
    
    'loading net sprites
    BLOAD "img\net_0.bmp",0
    net_sprite(0) = IMAGECREATE(50,125)
    GET (0,0)-(49,124), net_sprite(0)
    BLOAD "img\net_1.bmp",0
    net_sprite(1) = IMAGECREATE(50,125)
    GET (0,0)-(49,124), net_sprite(1)
    
    'loading pitch grass
    BLOAD "img\pitch.bmp",0
    pitch_sprite(0) = IMAGECREATE(32,32)
    GET (0,0)-(31,31), pitch_sprite(0)
    pitch_sprite(1) = IMAGECREATE(32,32)
    GET (32,0)-(63,31), pitch_sprite(1)
    
    'loading advertising banner
    BLOAD "img\banner.bmp",0
    banner_sprite = IMAGECREATE(256,24)
    GET (0,0)-(255,23), banner_sprite
    
    'loading the shadowet texture
    BLOAD "img\shadowed.bmp",0
    shadowed_sprite = IMAGECREATE(32,32)
    GET (0,0)-(31,31), shadowed_sprite
    
END SUB

SUB paint_kits(color_shirt_0 as Uinteger, color_pants_0 as Uinteger,_
color_shirt_1 as Uinteger, color_pants_1 as Uinteger)

Dim pitch As Integer
Dim pixels As Any Ptr
Dim count as Integer
dim as Integer img_w = 0
dim as Integer img_h = 0

for count = 0 to PL_SPRITES_TOT_N - 1
    If 0 <> ImageInfo( pl_sprite_0(count),img_w ,img_h,, pitch, pixels ) Then
        Print "unable to retrieve image information."
        Sleep
        End
    End If
    'Paint the sprite white the selected color image by directly manipulating pixel memory.
    For y As Integer = 0 To img_h
        Dim row As UInteger Ptr = pixels + y * pitch
        
        For x As Integer = 0 To img_w
            if row[x] = COLOR_KIT_SHIRT then
                row[x] = color_shirt_0
            end if
            if row[x] = COLOR_KIT_PANTS then
                row[x] = color_pants_0
            end if
            if row[x]= COLOR_KIT_LINE then
                row[x] = color_pants_0
            end if
        Next x
    Next y
    If 0 <> ImageInfo( pl_sprite_1(count),img_w ,img_h,, pitch, pixels ) Then
        Print "unable to retrieve image information."
        Sleep
        End
    End If
    'Paint the sprite white the selected color image by directly manipulating pixel memory.
    For y As Integer = 0 To img_h
        Dim row As UInteger Ptr = pixels + y * pitch
        
        For x As Integer = 0 To img_w
            if row[x] = COLOR_KIT_SHIRT then
                row[x] = color_shirt_1
            end if
            if row[x] = COLOR_KIT_PANTS then
                row[x] = color_pants_1
            end if
            if row[x]= COLOR_KIT_LINE then
                row[x] = color_pants_1
            end if
        Next x
    Next y
next count

END SUB


SUB delete_bitmap()
    dim count as Byte
    For count = 0 To PL_SPRITES_TOT_N
        If pl_sprite_0(count) Then ImageDestroy pl_sprite_0(count)
        If pl_sprite_1(count) Then ImageDestroy pl_sprite_1(count)
    Next
    For count = 0 To 14
        If ball_sprite(count) Then ImageDestroy ball_sprite(count)
    Next
    If net_sprite(0)   Then ImageDestroy net_sprite(0)
    If net_sprite(1)   Then ImageDestroy net_sprite(1)
    If pitch_sprite(0) Then ImageDestroy pitch_sprite(0)
    If pitch_sprite(1) Then ImageDestroy pitch_sprite(1)
    If banner_sprite   Then ImageDestroy banner_sprite
    If shadowed_sprite Then ImageDestroy shadowed_sprite
END SUB

'DATA 0,0        '0
'DATA 0,5        '1
'DATA 6,11       '2
'DATA 6,11       '3
'DATA 6,11       '4
'
SUB draw_pitch()
    dim as Ubyte pitch_rows, pitch_cols
    dim as Ubyte a, b
    dim banner_message as string*32
    pitch_rows = pitch_w / 32
    pitch_cols = pitch_h / 32
    
    
    Paint (SCREEN_W/2,SCREEN_H/2), COLOR_DARK_GREEN
    
    'banner
    PUT (PITCH_MIDDLE_W - c_x_o - 128, PITCH_Y - 27 - c_y_o), banner_sprite, trans
    banner_message = GAME_NAME + " " + str(GAME_VERSION) + " ::: " + str(goal_team_0) + "-" + str(goal_team_1)
    draw string (PITCH_MIDDLE_W - c_x_o - 120,  PITCH_Y - 20 - c_y_o), banner_message, RGB(50,50,50)
    'drawing the grass
    for a = 0 to pitch_cols -1
        for b = 0 to pitch_rows -1
            if is_in_camera_crop (PITCH_X + b*32, PITCH_Y + a*32, 128) then
                if b mod 2 = 0 then
                    PUT (PITCH_X + (b*32)- c_x_o, PITCH_Y+(a*32) - c_y_o),pitch_sprite(0),trans
                else
                    PUT (PITCH_X + (b*32)- c_x_o, PITCH_Y+(a*32) - c_y_o),pitch_sprite(1),trans
                end if
            end if
        next b
    next a
    'drawing the pitch's lines
    Line (PITCH_X - c_x_o, PITCH_Y - c_y_o)-(PITCH_W+PITCH_X- c_x_o, PITCH_H+PITCH_Y- c_y_o),RGB (255,255,255),b
    
    Line (PITCH_X+PITCH_W\2 - c_x_o, PITCH_Y - c_y_o)-(PITCH_X+PITCH_W\2 - c_x_o, PITCH_Y+PITCH_H - c_y_o),RGB (255,255,255)
    Circle (PITCH_X+PITCH_W\2- c_x_o, PITCH_Y + PITCH_H\2- c_y_o), 84,RGB (255,255,255)
    Circle (PITCH_X+PITCH_W\2- c_x_o, PITCH_Y + PITCH_H\2- c_y_o), 2,RGB (255,255,255),,,,F
    Circle (PITCH_X + 102 - c_x_o, PITCH_Y + PITCH_H\2 - c_y_o), 2,RGB (255,255,255),,,,F
    Circle (PITCH_X+PITCH_W - 102 - c_x_o, PITCH_Y + PITCH_H\2 - c_y_o), 2,RGB (255,255,255),,,,F
    
    Line (PITCH_X - c_x_o, PITCH_Y+PITCH_H\2 - c_y_o-84)-(PITCH_X - c_x_o+51, PITCH_Y+PITCH_H\2 - c_y_o+84),RGB (255,255,255),B
    Line (PITCH_X - c_x_o, PITCH_Y+PITCH_H\2 - c_y_o-186)-(PITCH_X - c_x_o+154, PITCH_Y+PITCH_H\2 - c_y_o+186),RGB (255,255,255),B
    Line (PITCH_X+PITCH_W - c_x_o, PITCH_Y+PITCH_H\2 - c_y_o-84)-(PITCH_X+PITCH_W - c_x_o-51, PITCH_Y+PITCH_H\2 - c_y_o+84),RGB (255,255,255),B
    Line (PITCH_X+PITCH_W - c_x_o, PITCH_Y+PITCH_H\2 - c_y_o-186)-(PITCH_X+PITCH_W - c_x_o-154, PITCH_Y+PITCH_H\2 - c_y_o+186),RGB (255,255,255),B
    Circle (PITCH_X + 102 - c_x_o, PITCH_Y + PITCH_H\2 - c_y_o), 84,RGB (255,255,255),5.4,0.9
    Circle (PITCH_X+PITCH_W - 102 - c_x_o, PITCH_Y + PITCH_H\2 - c_y_o), 84,RGB (255,255,255),2.26,4.04
    
    Circle (PITCH_X - c_x_o, PITCH_Y - c_y_o), 9, RGB(255,255,255),pi*1.5,0
    Circle (PITCH_X - c_x_o, PITCH_Y + PITCH_H - c_y_o), 9, RGB(255,255,255),0,pi/2
    Circle (PITCH_X+PITCH_W - c_x_o, PITCH_Y - c_y_o), 9, RGB(255,255,255),pi,pi*1.5
    Circle (PITCH_X+PITCH_W - c_x_o, PITCH_Y + PITCH_H - c_y_o), 9, RGB(255,255,255),pi/2,pi
    if (DEBUG) then
        Circle (PITCH_X - c_x_o, PITCH_Y + PITCH_H/2 - c_y_o),  PITCH_PENALTY_AREA, RGB(255,255,255), PI + PI/2, PI/2 , 1
        Circle (PITCH_X + PITCH_W -c_x_o, PITCH_Y + PITCH_H/2 - c_y_o),  PITCH_PENALTY_AREA, RGB(255,255,255), PI/2, PI + PI/2, 1
    end if
END SUB

SUB get_user_input()
    
    
    'position of the ball
    If MultiKey(SC_SPACE    ) then ball.z_speed_init = 15 : ball.z_speed=ball.z_speed_init
    
    If (MultiKey(SC_RIGHT ) and MultiKey(SC_UP)) then ball.rds = PI8: ball.speed +=1: 
    If (MultiKey(SC_LEFT ) and MultiKey(SC_UP)) then ball.rds = PI8*3: ball.speed +=1: 
    If (MultiKey(SC_LEFT ) and MultiKey(SC_DOWN)) then ball.rds = PI8*5: ball.speed +=1: 
    If (MultiKey(SC_RIGHT ) and MultiKey(SC_DOWN)) then ball.rds = PI8*7: ball.speed +=1: 
    If MultiKey(SC_LEFT ) then ball.rds = -PI : ball.speed +=1: 
    If MultiKey(SC_RIGHT) then ball.rds = 0: ball.speed +=1: 
    If MultiKey(SC_UP   ) then ball.rds = PI/2: ball.speed +=1: 
    If MultiKey(SC_DOWN   ) then ball.rds = (PI*2)*.75: ball.speed +=1: 
    
    If MultiKey(SC_D    ) then  DEBUG xor = 1 : 
    
END SUB

SUB update_ball()
    
    ball.old_x = ball.x
    ball.old_y = ball.y
    'this to desn't allow the ball to become a missile
    if ball.speed > BALL_MAX_SPEED then ball.speed = BALL_MAX_SPEED
    if ball.speed < BALL_MIN_SPEED then ball.speed = 0
    
    'ball bounce physics
    if ball.z_speed > 0 then
        ball.z += ball.z_speed - GRAVITY_ACCEL
        ball.z_speed *= GRAVITY
        ball.speed = ball.speed * AIR_FRICTION
        if (ball.z <=0) then
            ball.z_speed_init *= BOUNCE_FRICTION
            ball.z_speed = ball.z_speed_init
            ball.z = 0
        end if
    else
        if ball.z < 0.5 then ball.z = 0
        ball.speed = ball.speed * friction
    end if
    
    'ball position
    ball.x += cos(ball.rds)*ball.speed
    ball.y += -sin(ball.rds)*ball.speed
    
    'radiants check -> MOD 2*PI
    if ball.rds > PI*2 THEN ball.rds = ball.rds - PI*2
    if ball.rds < 0 THEN ball.rds = ball.rds + PI*2
    
END SUB

SUB draw_ball()
    dim offset_frame as UByte
    dim x as Ubyte
    
    if (ball.z > 25) then
        if ball.z < 60 then
            offset_frame = 5
        else
            offset_frame = 10
        end if
    else
        offset_frame = 0
    end if
    
    if d_b_t_p(ball.x, ball.y, ball.old_x, ball.old_y) > 1 then
        ball.frame += 1
    end if
    
    if ball.frame MOD 5 = 0  then ball.frame = 0
    
    'shadow
    circle (ball.x-c_x_o, ball.y-c_y_o+2),ball.w, RGB (0,50,0),,,,F
    PUT (ball.x-c_x_o-8, ball.y- 8 - ball.z- c_y_o), ball_sprite(ball.frame + offset_frame), trans
END SUB

SUB ball_border_pitch_limit_check()
    'goal check team 0
    if (ball.x > PITCH_X + PITCH_W - 5) and (ball.y + ball.w < PITCH_H /2 + PITCH_NET_W/2 + PITCH_Y)_
    and (ball.y + ball.w > PITCH_H /2 - PITCH_NET_W/2 + PITCH_Y) and ball.z < PITCH_NET_H then
    ball_put_on_centre()
    reset_players_positions()
    goal_team_0 +=1
    camera.speed = 0
    PL_ball_owner_id = -1
    exit sub
end if

'goal check team 1
if (ball.x < PITCH_X + 5) and (ball.y + ball.w < PITCH_H /2 + PITCH_NET_W/2 + PITCH_Y)_
and (ball.y + ball.w > PITCH_H /2 - PITCH_NET_W/2 + PITCH_Y) and ball.z < PITCH_NET_H then
ball_put_on_centre()
reset_players_positions()
goal_team_1 +=1
camera.speed = 0 
PL_ball_owner_id = -1
exit sub
end if

'border pitch limit check
if (ball.x + ball.w > PITCH_X+PITCH_W) THEN
    ball.x = PITCH_X+PITCH_W-5
    ball.rds = PI - ball.rds
    ball.speed *= 0.3:ball.z_speed *= 0.5
    PL_ball_owner_id = -1
END IF
if (ball.x - ball.w < PITCH_X) THEN
    ball.x = PITCH_X+5
    ball.rds = PI - ball.rds
    ball.speed *= 0.3:ball.z_speed *= 0.5
    PL_ball_owner_id = -1
END IF
if (ball.y + ball.w > PITCH_Y+PITCH_H) THEN
    ball.y = PITCH_Y+PITCH_H-5
    ball.rds = PI*2 - ball.rds
    ball.speed *= 0.3:ball.z_speed *= 0.5
    PL_ball_owner_id = -1
END IF
if (ball.y - ball.w < PITCH_Y) THEN
    ball.y = PITCH_Y+5
    ball.rds = PI*2 - ball.rds
    ball.speed *= 0.3
    ball.z_speed *= 0.5
    PL_ball_owner_id = -1
END IF
END SUB

SUB draw_grid()
    dim as integer x, y, x2,y2, col, row, count
    count = 0
    for row = 0 to ROW_TOT_N - 1 step 1
        for col = COL_TOT_N - 1 to 0 step -1
            'draw the grid
            x = row * PITCH_W / ROW_TOT_N + PITCH_X 
            y = col * PITCH_H / COL_TOT_N + PITCH_Y
            x2 = x + PITCH_W / ROW_TOT_N
            y2 = y + PITCH_H / COL_TOT_N
            line (x-c_x_o,y-c_y_o)-(x2-c_x_o,y2-c_y_o),RGB(255,0,255),b
            draw string (x+5-c_x_o,y+5-c_y_o), str(count), RGB(75,150,20)
            'check if the ball is into a box of the grid and fill it using paint function
            if (ball.x > x) and (ball.x < x2) and (ball.y>y) and (ball.y < y2) then
                paint (ball.x-c_x_o, ball.y-c_y_o),RGB (50,150,15),RGB(255,0,255)
                draw string (x+5-c_x_o,y+5-c_y_o), str(count)
            end if
            count +=1
        next col   
    next row
END SUB

SUB ball_put_on_centre()
    ball.rds = 0
    ball.x = 1+ PITCH_MIDDLE_W
    ball.y = 1+ PITCH_MIDDLE_H
    ball.z = 0
    ball.z_speed = 0
    ball.speed = 0
    ball.w = 4
    ball.frame=0
    
END SUB

SUB reset_players_positions()
    dim c as Ubyte
    for c = 0 to (N_TOT_PL*2-1)
        select case c
        'goalkeepers
        case 0, 1
            if c = 0 then
                pl(c).x = PITCH_X + 10
                pl(c).y = PITCH_Y + PITCH_H / 2
                pl(c).rds = 0
            else
                pl(c).x = PITCH_X + PITCH_W - 10
                pl(c).y = PITCH_Y + PITCH_H / 2
                pl(c).rds = PI
            end if
            'other players
        case else
            if c mod 2 = 0 then
                pl(c).x = rnd * PITCH_W/2 + PITCH_X
                pl(c).y = rnd * PITCH_H + PITCH_Y
            else
                pl(c).x = rnd * PITCH_W/2 + PITCH_X + PITCH_W/2
                pl(c).y = rnd * PITCH_H + PITCH_Y
            end if
        end select
        pl(c).active = 1
        pl(c).action = 1
    next c
END SUB


SUB draw_players()
    dim as Ubyte b, c, lowest, start, change
    dim as integer ref
    dim a(N_TOT_PL * 2,2) as integer
    
    b = 0
    
    'z sorting by pl.y value - using selection sorting algorithm
    
    for c = 0 to N_TOT_PL * 2-1
        a(c,0) = c
        a(c,1) = pl(c).y
    next c
    
    for start = 0 to N_TOT_PL * 2 - 1 
        ref = a(start,1)
        change = 0 
        for b = start+1 to N_TOT_PL * 2 - 1 
            if a(b,1) < ref then
                ref = a(b, 1)
                lowest = b
                change = 1
            end if
        next b
        if change then
            swap a(lowest, 0), a(start, 0)
            swap a(lowest, 1), a(start, 1)
        end if
    next start
    
    'draws players, shadow, and circle under nearest pl to the ball
    for c = 0 to N_TOT_PL * 2 - 1
        'draws circles yellow or red under the nearest pl to the ball
        if get_nrst_pl_ball(pl(a(c,0)).team) = a(c,0) then 
            if pl(a(c,0)).team = 0 then
                circle (pl(a(c,0)).x - c_x_o, pl(a(c,0)).y+9 - c_y_o),9, RGB (200,0,100),,,,F
                circle (pl(a(c,0)).x - c_x_o, pl(a(c,0)).y+9 - c_y_o),6, RGB (0,50,0),,,,F
                
            else
                circle (pl(a(c,0)).x- c_x_o, pl(a(c,0)).y+9 - c_y_o),9, RGB (255,255,0),,,,F
                circle (pl(a(c,0)).x - c_x_o, pl(a(c,0)).y+9 - c_y_o),6, RGB (0,50,0),,,,F
                
            end if
            draw string (pl(a(c,0)).x -6- c_x_o, pl(a(c,0)).y -30  - c_y_o), str(pl(a(c,0)).number)    
            'draw string (pl(a(c,0)).x -6- c_x_o, pl(a(c,0)).y -60  - c_y_o), str(pl(a(c,0)).speed)    'DEBUG
            'draw string (pl(a(c,0)).x -6- c_x_o, pl(a(c,0)).y -45  - c_y_o), str(pl(a(c,0)).active)    'DEBUG
        end if
        
        'puts the right set of sprites depending on the pl.action
        if is_in_camera_crop (pl(a(c,0)).x, pl(a(c,0)).y, 128) then
            select case pl(a(c,0)).action
            case 0 '*** at this moment undefined***
            case 1 'RUNNING############################################################
                pl(a(c,0)).dist += pl(a(c,0)).speed /7
                if pl(a(c,0)).dist > 1 then
                    pl(a(c,0)).frame+=1
                    pl(a(c,0)).dist =0
                end if
                if pl(a(c,0)).speed = 0 then pl((a(c,0))).frame = 0
                if pl(a(c,0)).frame > 5 then pl(a(c,0)).frame=1
                if pl(a(c,0)).team = 0 then
                    PUT (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
                    pl_sprite_0(start_frame(pl(a(c,0)).rds)+pl(a(c,0)).frame), trans
                else
                    PUT (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
                    pl_sprite_1(start_frame(pl(a(c,0)).rds)+pl(a(c,0)).frame), trans
                end if
            case 2 'JUMPING for HEADKICKS##############################################
                if pl(a(c,0)).team = 0 then
                    PUT (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
                    pl_sprite_0(start_frame(pl(a(c,0)).rds)+13), trans
                else
                    PUT (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
                    pl_sprite_1(start_frame(pl(a(c,0)).rds)+13), trans
                end if
            case 3 'SLIDING ###########################################################
                if pl(a(c,0)).team = 0 then
                    PUT (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
                    pl_sprite_0(start_frame(pl(a(c,0)).rds)+12), trans
                else
                    PUT (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
                    pl_sprite_1(start_frame(pl(a(c,0)).rds)+12), trans
                end if
            case 4 'FALLING ###########################################################
                pl(a(c,0)).frame_offset +=1
                if pl(a(c,0)).frame_offset > 9 then pl(a(c,0)).frame_offset = 0
                if pl(a(c,0)).team = 0 then
                    PUT (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
                    pl_sprite_0(start_frame(pl(a(c,0)).rds)+int(pl(a(c,0)).frame_offset/2)+6), trans
                else
                    PUT (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
                    pl_sprite_1(start_frame(pl(a(c,0)).rds)+int(pl(a(c,0)).frame_offset/2)+6), trans
                end if
            case 5
                if pl(a(c,0)).team = 0 then
                    PUT (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
                    pl_sprite_0(start_frame(pl(a(c,0)).rds)+6), trans
                else
                    PUT (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
                    pl_sprite_1(start_frame(pl(a(c,0)).rds)+6), trans
                end if
            case else
            end select
        end if
    next c
    
END SUB

SUB update_players()
    dim c as Ubyte
    dim decision as Ubyte = 0
    dim pl_to_pass as Ubyte = 0
    dim trg_x as single
    dim trg_y as single
    
    
    
    'the following is a very bad try to give a decent AI to the players
    for c = 0 to N_TOT_PL * 2 - 1
        'this is useful for the pl behaviour
        decision = rnd*100
        'this is useful for the sprites
        pl(c).old_x = pl(c).x
        pl(c).old_y = pl(c).y
        'delay check
        if pl(c).active = 0 then 
            pl(c).delay -=1
        end if
        
        select case pl(c).action
        case 0
        case 1 '#### RUNNING ##########################################################
            'goalkeepers routine
            if c < 2 then
                trg_x = PITCH_X + 25 +((PITCH_W - 50) * (pl(c).team xor 0))
                trg_y = PITCH_MIDDLE_H 
                ' if the ball is into the area then the GK runs to the ball
                if d_b_t_p(trg_x, trg_y, ball.x, ball.y) < PITCH_PENALTY_AREA -50 then
                    pl(c).rds = a_b_t_p(pl(c).x,pl(c).y, ball.x,ball.y)
                    pl(c).speed = 5
                    ' if the ball is VERY near, kick off the ball
                    if d_b_t_p(pl(c).x,pl(c).y, ball.x, ball.y) < 15 and ball.z < 15 then
                        ball.speed = 7*rnd+10
                        ball.z_speed_init = 10 + rnd*5 : ball.z_speed=ball.z_speed_init
                        ball.rds = PI * (pl(c).team xor 0)
                        PL_target_id = -1 ' The GK is not passing to anyone
                        PL_ball_owner_id = c ' The pl become the ball owner
                    end if
                    'else return to the net
                else
                    'keep running to the net until the distance is more than 5
                    if d_b_t_p(pl(c).x, pl(c).y, trg_x, trg_y) > 5 then
                        pl(c).rds = a_b_t_p(pl(c).x,pl(c).y, trg_x, trg_y)
                        pl(c).speed = 3
                        'when get the net stay there
                    else
                        pl(c).speed = 0
                        pl(c).x = trg_x
                        pl(c).y = trg_y
                        'when stay in the net always watch the ball
                        pl(c).rds = a_b_t_p(pl(c).x,pl(c).y, ball.x, ball.y)
                    end if
                end if
            else
                'routine for other players (defenders, midfielders, attackers)#########
                'if the pl(c) is the nearest to the ball and is ready to perform an 
                'action then run there
                if get_nrst_pl_ball(pl(c).team) = c then
                    'run to the ball and restore original speed of the player
                    pl(c).speed = pl(c).speed_default
                    pl(c).rds =  a_b_t_p(pl(c).x,pl(c).y, ball.x,ball.y)
                    ' try to catch the ball with SLIDING###############################
                    'if the pl slider is not receiving the ball and if
                    'the ball distance is into a specified range (in this case >30 <50)
                    '(...) and also important: the ball.z must be less than a fixed value
                    if (decision > 90 and (PL_ball_owner_id <> c) and (PL_target_id <> c)_
                    and (d_b_t_p(pl(c).x, pl(c).y,ball.x, ball.y)) < 50 _
                    and (d_b_t_p(pl(c).x, pl(c).y,ball.x, ball.y)) > 30 _
                    and ball.z < 5) then
                        pl(c).speed = 15
                        pl(c).delay = 20
                        pl(c).action = 3 '3 = sliding
                        continue for
                    end if
                    'try to hit the ball with HEADKICK################################
                    'if the ball is near and its z value is greater than a fixed value
                    'then the player tries to hit it with headkick
                    if (decision > 80 and (PL_ball_owner_id <> c) _
                    and (d_b_t_p(pl(c).x, pl(c).y,ball.x, ball.y)) < 40 _
                    and ball.z > 6 and ball.z < 30) then
                        pl(c).speed = 12
                        pl(c).delay = 10
                        pl(c).action = 2 '3 = sliding
                        continue for
                    end if
                'if the ball is very near and at the same z level of the pl the
                'pl became owner of the ball
                '#PLAYER OWNER OF THE BALL#
                if d_b_t_p(pl(c).x,pl(c).y, ball.x,ball.y) < 6 and ball.z < 4 then
                    ' if there is enough room - run to the opponent net
                    if d_b_t_p (pl(c).x,pl(c).y,_
                    pl(get_nrst_pl_ball(pl(c).team xor 1)).x,_
                    pl(get_nrst_pl_ball(pl(c).team xor 1)).y) > PL_RUN_SPACE then
                    reset_ball_z()
                    ball.rds = a_b_t_p (pl(c).x, pl(c).y,_
                    PITCH_X + (PITCH_W * (pl(c).team xor 1)), PITCH_MIDDLE_H) + rnd * .5 -.25
                    ball.speed = pl(c).speed + rnd*2 + 1
                    PL_target_id = -1 ' The pl is not passing to anyone
                    PL_ball_owner_id = c ' The pl become the ball owner
                else
                    'get the pl behaviour
                    get_pl_behavior(c)
                end if
                continue for
            end if
            'else follow the tactics
        else
            ' if the pl owns the id that is receiving the ball, him runs to the
            'ball with a little speed help
            if c = PL_target_id then
                pl(c).rds = a_b_t_p(pl(c).x,pl(c).y, ball.x, ball.y)
                pl(c).speed = pl(c).speed_default * 1.2
            else
                'else follow the tactics
                pl(c).speed = pl(c).speed_default
                pl(c).rds = get_rds_from_tile(get_tact_tile(c),pl(c).x + pl(c).tact_offset_x,pl(c).y+ pl(c).tact_offset_y)
                if get_dist_from_tile (get_tact_tile(c), pl(c).x + pl(c).tact_offset_x,pl(c).y + pl(c).tact_offset_y) < 5 then 
                    pl(c).speed = 0
                    'offset to the tactic to move randomly the the player (I don't like mummies)
                    if int(rnd * 100) > 85 then
                        pl(c).tact_offset_x = rnd * 30-15
                        pl(c).tact_offset_y = rnd * 30-15
                    end if
                else
                    pl(c).speed = pl(c).speed_default
                end if
            end if
        end if
    end if
case 2 'HEADKICKING#####################################################################
    pl(c).speed *= 0.85 'friction of the pl body with the air
    pl(c).delay -= 1
    'if the delay time has passed 
    if pl(c).delay < 1 then
        pl(c).action = 1
        pl(c).delay = PL_DELAY_FALLED
    end if
    'Oh yeah, I can headkicking, the ball is so near!
    if (d_b_t_p(pl(c).x,pl(c).y, ball.x,ball.y) < 20 and ball.z < 20 and ball.z > 6) then
        ball.rds = pl(c).rds + (PI/2 - PI/4)
        ball.speed = pl(c).speed + rnd * 5 + 5
        if (int(rnd*10)> 5) then
            ball.z_speed_init = 10 : ball.z_speed=ball.z_speed_init
        end if
        PL_ball_owner_id = c
        pl(c).speed = pl(c).speed_default
    end if
case 3 'SLIDING#####################################################################
    pl(c).speed *= 0.80 'friction of the pl body with the grass
    pl(c).delay -= 1
    'if the delay time has passed or the pl has catched the ball
    if pl(c).delay < 1 or _
    (d_b_t_p(pl(c).x,pl(c).y, ball.x,ball.y) < 6 and ball.z < 4) then
        pl(c).action = 1
        pl(c).delay = PL_DELAY_FALLED
        pl(c).speed = pl(c).speed_default
    end if
case 4 'falling ... delays and goto falled
    pl(c).speed *=0.1
    if pl(c).delay < 1 then
        pl(c).action = 5 
        pl(c).delay = PL_DELAY_FALLED
    end if
case 5 'falled
    pl(c).speed = 0
    if pl(c).delay < 1 then
        pl(c).active = 1
        pl(c).action = 1
        pl(c).delay = PL_DELAY_FALLED
        pl(c).speed = pl(c).speed_default
    end if
case else
end select
'pl limit check, don't go outside the PITCH
if pl(c).x > PITCH_W + PITCH_X then pl(c).rds = a_b_t_p(pl(c).x, pl(c).y,PITCH_MIDDLE_W,PITCH_MIDDLE_H)
if pl(c).x < PITCH_X then pl(c).rds = a_b_t_p(pl(c).x, pl(c).y,PITCH_MIDDLE_W,PITCH_MIDDLE_H)
if pl(c).y > PITCH_H + PITCH_Y then pl(c).rds = a_b_t_p(pl(c).x, pl(c).y,PITCH_MIDDLE_W,PITCH_MIDDLE_H)
if pl(c).y < PITCH_Y then pl(c).rds = a_b_t_p(pl(c).x, pl(c).y,PITCH_MIDDLE_W,PITCH_MIDDLE_H)

'###IMPORTANT!#####
'update pl position moving him
pl(c).x +=  cos(pl(c).rds)*pl(c).speed
pl(c).y +=  -sin(pl(c).rds)*pl(c).speed
next c
END SUB

SUB camera_update_position()
    camera.speed = d_b_t_p(camera.x, camera.y, ball.x, ball.y) / 6
    camera.x += cos(a_b_t_p(camera.x, camera.y, ball.x, ball.y))*camera.speed
    camera.y += -sin(a_b_t_p(camera.x, camera.y, ball.x, ball.y))*camera.speed
    
    'padding & border limit check
    if (camera.x < PITCH_X + camera.w/2 - CAMERA_PADDING) then
        camera.x = PITCH_X + camera.w/2 - CAMERA_PADDING
    end if
    if (camera.x > PITCH_X + PITCH_W - camera.w/2 + CAMERA_PADDING) then
        camera.x = PITCH_X + PITCH_W - camera.w/2 + CAMERA_PADDING
    end if
    if (camera.y > PITCH_Y + PITCH_H - camera.h/2 + CAMERA_PADDING) then
        camera.y = PITCH_Y + PITCH_H - camera.h/2 + CAMERA_PADDING
    end if
    if (camera.y < PITCH_Y + camera.h/2 - CAMERA_PADDING) then
        camera.y = PITCH_Y + camera.h/2 - CAMERA_PADDING
    end if
    'update global variables
    c_x_o = camera.x - camera.w/2
    c_y_o = camera.y - camera.h/2
END SUB

SUB init_players_proprietes()
    'initializing players proprietes
    dim c as Ubyte
    for c = 0 to (N_TOT_PL*2-1)
        select case c
        'goalkeepers
        case 0, 1
            if c = 0 then
                pl(c).id = c
                pl(c).team = 0
                pl(c).number = int (c / 2)+1
                pl(c).x = PITCH_X + 10
                pl(c).y = PITCH_Y + PITCH_H / 2
                pl(c).rds = 0
                pl(c).speed_default = 0
                pl(c).speed = pl(c).speed_default
            else
                pl(c).id = c
                pl(c).team = 1
                pl(c).number = int (c / 2)+1
                pl(c).x = PITCH_X + PITCH_W - 10
                pl(c).y = PITCH_Y + PITCH_H / 2
                pl(c).rds = PI
                pl(c).speed_default = 0
                pl(c).speed = pl(c).speed_default
            end if
            pl(c).frame = 0
            
            pl(c).tact_offset_x = rnd * 60 - 30
            pl(c).tact_offset_y = rnd * 60 - 30
            pl(c).ball_radius = 25
            pl(c).w = 10
            pl(c).delay = PL_DELAY_TIME
            pl(c).active = 1 ' by default the pl is ready to perform any action
            pl(c).action = 1 'by default the pl can run
            'other players
        case else
            if c mod 2 = 0 then
                pl(c).id = c
                pl(c).team = 0
                pl(c).number = int (c / 2)+1
                pl(c).x = rnd * PITCH_W/2 + PITCH_X
                pl(c).y = rnd * PITCH_H + PITCH_Y
                
            else
                pl(c).id = c
                pl(c).team = 1
                pl(c).number = int (c / 2)+1
                pl(c).x = rnd * PITCH_W/2 + PITCH_X + PITCH_W/2
                pl(c).y = rnd * PITCH_H + PITCH_Y
            end if
            pl(c).rds = 0
            pl(c).frame = 0
            pl(c).frame_offset = 0
            pl(c).dist = 0
            pl(c).speed_default = rnd*(PL_DEFAULT_SPEED*2) + PL_DEFAULT_SPEED*2
            pl(c).speed = pl(c).speed_default
            
            pl(c).tact_offset_x = rnd * 60 - 30
            pl(c).tact_offset_y = rnd * 60 - 30
            pl(c).ball_radius = 25
            pl(c).w = 10
            pl(c).delay = PL_DELAY_TIME
            pl(c).active = 1 ' by default the pl is ready to perform any action
            pl(c).action = 1 'by default the pl can run
        end select
    next c
    'initialize who is receiving the ball (none)
    PL_target_id = -1
END SUB

SUB draw_nets()
    
    'left net
    line (PITCH_X - c_x_o, PITCH_MIDDLE_H - c_y_o)-(PITCH_X + 5 - c_x_o, PITCH_MIDDLE_h - c_y_o)
    line (PITCH_X - c_x_o, PITCH_MIDDLE_H + PITCH_NET_W/2- c_y_o)-(PITCH_X + 5 - c_x_o, PITCH_MIDDLE_H + PITCH_NET_W/2 - c_y_o)
    line (PITCH_X - c_x_o, PITCH_MIDDLE_H - PITCH_NET_W/2- c_y_o)-(PITCH_X + 5 - c_x_o, PITCH_MIDDLE_H - PITCH_NET_W/2 - c_y_o)
    
    'right net
    line (PITCH_X + PITCH_W - c_x_o, PITCH_MIDDLE_H - c_y_o)-(PITCH_X - 5 + PITCH_W - c_x_o, PITCH_MIDDLE_H - c_y_o)
    line (PITCH_X + PITCH_W -c_x_o, PITCH_MIDDLE_H + PITCH_NET_W/2- c_y_o)-(PITCH_X + PITCH_W - 5 - c_x_o, PITCH_MIDDLE_H + PITCH_NET_W/2 - c_y_o)
    line (PITCH_X + PITCH_W - c_x_o, PITCH_MIDDLE_H - PITCH_NET_W/2- c_y_o)-(PITCH_X + PITCH_W - 5 - c_x_o, PITCH_MIDDLE_H - PITCH_NET_W/2 - c_y_o)
    
    PUT (PITCH_X - 50 - c_x_o, PITCH_MIDDLE_H - PITCH_NET_W/2 - PITCH_NET_H - c_y_o ), net_sprite(0), trans
    PUT (PITCH_X + PITCH_W - c_x_o, PITCH_MIDDLE_H - PITCH_NET_W/2 - PITCH_NET_H - c_y_o ), net_sprite(1), trans
    
end sub


SUB load_tact()
    'the "tct_tile" array indicates in wich tile the player must be with corresponding
    'ball position. For example: ball in tile 0 -> read from tct_tile(0) = player in tile 1
    dim tl as Byte = 0
    dim c as Byte = 0
    
    For c = 0 To 9
        for tl = 0 to 35
            Read tct_tile(c,tl)
        next tl
    Next c
    
END SUB

'TACT DATA
'each row represents in wich tile the pl must go when he doesn't own the ball
'So, the defender (id: 1) must go to these tiles:
'DATA 	1,1,2,2,2,2,7,7,2,2 [...] etc
' when the ball is in the tile 0, he must go to tile 1
' when the ball is in the tile 1, he must go to tile 1
' when the ball is in the tile 2, he must go to tile 2 [...] and so on...

DATA    1,1,1,1,1,1,1,1,1,1,1,1,7,7,7,7,7,7,7,7,7,7,7,7,13,13,13,13,13,13,13,13,13,13,13,13
DATA    2,2,2,2,2,2,2,2,2,2,2,2,8,8,8,8,8,8,8,8,8,8,8,8,14,14,14,14,14,14,14,14,14,14,14,14
DATA    3,3,3,3,3,3,3,3,3,3,3,3,9,9,9,9,9,9,9,9,9,9,9,9,9,15,15,15,15,15,15,15,15,15,15,15
DATA    4,4,4,4,4,4,4,4,4,4,4,4,10,10,10,10,10,10,10,10,10,10,10,10,16,16,16,16,16,16,16,16,16,16,16,16
DATA    12,13,13,13,13,13,12,13,13,13,13,13,13,13,13,13,13,13,19,19,19,19,19,19,19,19,19,25,25,25,30,25,25,25,25,25
DATA    14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,20,20,20,20,20,20,26,26,26,26,26,26,25,26,26,26,26,26
DATA    15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,21,21,21,21,21,21,27,27,27,27,27,27,27,27,27,27,27,28
DATA    17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,22,22,22,22,22,22,22,22,22,22,28,28,28,28,28,28,28,35
DATA    20,20,20,20,20,20,20,20,20,20,20,20,26,26,26,26,26,26,26,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32
DATA    21,21,21,21,21,21,21,21,21,21,21,21,27,27,27,27,27,27,27,33,33,33,33,28,33,33,33,33,33,33,33,33,33,33,33,33

'see comment below for details about the bhv_tile array
SUB load_behavior()
    dim tl as Ubyte = 0
    dim c as Ubyte = 0
    dim temp as Ubyte = 0
    'read and store into array
    For tl = 0 To 35
        for c = 0 to 9
            Read bhv_tile(tl,c)
        next c
    Next tl
    'transform 10, 20, 35 -> 10, (20+10) = 30, (10+20+35) = 65 [...] and so on
    For tl = 0 To 35
        for c = 1 to 9
            temp = bhv_tile(tl,c-1)
            bhv_tile(tl,c) += temp
        next c
    Next tl
    
END SUB
'BEHAVIOR DATA
'each row represents the behavior of the player OWNER of the ball in "x" tile
'every column represents a percentage [...]
'So, if the pl owns the ball in the 0 tile he could:
'DATA    [tile 0] 10,20,10,20,4,4,10,4,18,0
' 10% pass to nearest, 20% pass to 2nd nearest, 10% pass by short side,
'20% pass longside, 4% pass to the endline pl [...] and so on...

'fields meaning:
'0: pass_to_nearest; 1: pass_to_2nd_nearest; 2: pass_short_side; 3: pass_long_side
'4:pass_endline; 5: pass_center; 6: run_to_centre; 7: run_to_net
'8: run_to_endline; 9: shoot_in_target
'(see functions meaning on the top of this file)
'IMPORTANT: the SUM of each row is always 100

DATA    10,20,10,20,4,4,10,4,18,0
DATA    5,10,5,27,4,4,15,10,20,0
DATA    4,12,3,35,8,13,10,5,10,0
DATA    4,12,3,35,8,13,10,5,10,0
DATA    5,10,5,27,4,4,15,10,20,0
DATA    10,20,10,20,4,4,10,4,18,0
DATA    7,10,7,25,5,15,10,3,18,0
DATA    5,12,7,21,6,18,13,3,15,0
DATA    2,7,10,22,7,21,13,3,15,0
DATA    2,7,10,22,7,21,13,3,15,0
DATA    5,12,7,21,6,18,13,3,15,0
DATA    7,10,7,25,5,15,10,3,18,0
DATA    8,9,8,13,15,13,14,8,12,0
DATA    7,8,9,12,16,18,10,9,11,0
DATA    7,11,11,14,14,7,7,14,15,0
DATA    7,11,11,14,14,7,7,14,15,0
DATA    7,8,9,12,16,18,10,9,11,0
DATA    8,9,8,13,15,13,14,8,12,0
DATA    5,10,7,15,20,6,6,13,13,5
DATA    4,9,10,18,20,6,5,12,10,6
DATA    3,10,9,15,25,3,2,13,12,8
DATA    3,10,9,15,25,3,2,13,12,8
DATA    4,9,10,18,20,6,5,12,10,6
DATA    5,10,7,15,20,6,6,13,13,5
DATA    10,10,7,7,15,2,7,16,15,11
DATA    10,10,10,5,18,3,8,10,10,16
DATA    8,8,12,12,17,0,3,10,10,20
DATA    8,8,12,12,17,0,3,10,10,20
DATA    10,10,10,5,18,3,8,10,10,16
DATA    10,10,7,7,15,2,7,16,15,11
DATA    5,7,15,5,25,8,7,13,3,12
DATA    3,4,4,2,21,2,6,22,1,35
DATA    2,2,2,2,20,6,4,16,1,45
DATA    2,2,2,2,20,6,4,16,1,45
DATA    3,4,4,2,21,2,6,22,1,35
DATA    5,7,15,5,25,8,7,13,3,12

SUB get_pl_behavior(pl_id as Ubyte)
    dim tile as Byte '0-35
    dim decision as Byte '0-100
    dim pl_to_pass as Byte = 0
    
    decision = rnd*101
    tile = get_ball_tile(pl(pl_id).team)
    
    select case decision
    case 0 to bhv_tile(tile, 0) '0: PASS TO NEAREST
        SHELL_message =  str(decision) + " TILE " + str(tile) + " PASS to nearest"
        'setting ball proprietes (z, angle, speed)            
        reset_ball_z()
        ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,pl(get_nrst_pl_pass(pl_id)).x,pl(get_nrst_pl_pass(pl_id)).y)+rnd*.3-0.15
        ball.speed = get_passing_ball_speed (d_b_t_p(pl(pl_id).x, pl(pl_id).y,_
        pl(get_nrst_pl_pass(pl_id)).x,pl(get_nrst_pl_pass(pl_id)).y))
        
        PL_target_id = get_nrst_pl_pass(pl_id)
        PL_ball_owner_id = pl_id
        
        exit sub
    case bhv_tile(tile, 0)+1 to bhv_tile(tile, 1)'1: pass_to_2nd_nearest
        SHELL_message =  str(decision) + " - TILE " + str(tile) + " PASS 2nd nearest"
        pl_to_pass = rnd*2 + 1
        
        'setting ball proprietes (z, angle, speed)
        reset_ball_z()
        ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,_
        pl(get_nrst2_pl_pass(pl_id, pl_to_pass)).x,pl(get_nrst2_pl_pass(pl_id,pl_to_pass)).y)+rnd*.3-0.15
        ball.speed = get_passing_ball_speed (d_b_t_p(pl(pl_id).x, pl(pl_id).y,_
        pl(get_nrst2_pl_pass(pl_id, pl_to_pass)).x,pl(get_nrst2_pl_pass(pl_id,pl_to_pass)).y))
        
        PL_target_id = get_nrst2_pl_pass(pl_id,pl_to_pass)
        PL_ball_owner_id = pl_id
        exit sub
    case bhv_tile(tile, 1)+1 to bhv_tile(tile, 2)'2: pass_short_side
        SHELL_message =  str(decision) + " - TILE " + str(tile) + " PASS Short Side"
        
        'setting ball proprietes (z, angle, speed)            
        reset_ball_z()
        ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,pl(get_shortside_pl_to_pass(pl_id)).x,pl(get_shortside_pl_to_pass(pl_id)).y)+rnd*.3-0.15
        ball.speed = get_passing_ball_speed (d_b_t_p(pl(pl_id).x, pl(pl_id).y,_
        pl(get_shortside_pl_to_pass(pl_id)).x,pl(get_shortside_pl_to_pass(pl_id)).y))
        
        PL_target_id = get_shortside_pl_to_pass(pl_id)
        PL_ball_owner_id = pl_id
        
        exit sub
    case bhv_tile(tile, 2)+1 to bhv_tile(tile, 3)'3: pass_long_side
        SHELL_message =  str(decision) + " - TILE " + str(tile) + " PASS Long Side"
        
        reset_ball_z()
        ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,_
        pl(get_longside_pl_to_pass(pl_id)).x,pl(get_longside_pl_to_pass(pl_id)).y)
        ball.speed = get_passing_ball_speed (d_b_t_p(pl(pl_id).x, pl(pl_id).y,_
        pl(get_longside_pl_to_pass(pl_id)).x,pl(get_longside_pl_to_pass(pl_id)).y))
        
        PL_target_id = get_longside_pl_to_pass(pl_id)
        PL_ball_owner_id = pl_id
        exit sub
    case bhv_tile(tile, 3)+1 to bhv_tile(tile, 4)'4: pass_endline
        SHELL_message =  str(decision) + " - TILE " + str(tile) + " PASS Endline"
        
        'setting ball proprietes (z, angle, speed)
        
        if decision mod 2 = 0 then 
            reset_ball_z()
            ball.speed = get_passing_ball_speed (d_b_t_p(pl(pl_id).x, pl(pl_id).y,_
            pl(get_endline_pl_to_pass(pl_id)).x,pl(get_endline_pl_to_pass(pl_id)).y))
        else
            ball.z_speed_init = rnd*5+7 : ball.z_speed=ball.z_speed_init
            ball.speed = get_passing_ball_speed (d_b_t_p(pl(pl_id).x, pl(pl_id).y,_
            pl(get_endline_pl_to_pass(pl_id)).x,pl(get_endline_pl_to_pass(pl_id)).y)) / 5
        end if
        ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,_
        pl(get_endline_pl_to_pass(pl_id)).x,pl(get_endline_pl_to_pass(pl_id)).y)
        
        PL_target_id = get_endline_pl_to_pass(pl_id)
        PL_ball_owner_id = pl_id
        exit sub
    case bhv_tile(tile, 4)+1 to bhv_tile(tile, 5)'5: pass_center 
        SHELL_message =  str(decision) + " - TILE " + str(tile) + " PASS center"
        
        reset_ball_z()
        ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,_
        pl(get_centerest_pl_to_pass(pl_id)).x,pl(get_centerest_pl_to_pass(pl_id)).y)
        ball.speed = get_passing_ball_speed (d_b_t_p(pl(pl_id).x, pl(pl_id).y,_
        pl(get_centerest_pl_to_pass(pl_id)).x,pl(get_centerest_pl_to_pass(pl_id)).y))
        
        PL_target_id = get_centerest_pl_to_pass(pl_id)
        PL_ball_owner_id = pl_id
        
        exit sub
    case bhv_tile(tile, 5)+1 to bhv_tile(tile, 6)'6: run_to_centre
        SHELL_message =  str(decision) + " - TILE " + str(tile) + " R U N centre"
        ball.speed = pl(pl_id).speed + rnd*5 + 1
        ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y, pl(pl_id).x, PITCH_MIDDLE_H) + rnd * .5 -.25
        PL_target_id = -1 ' The pl is not passing to anyone
        PL_ball_owner_id = pl_id ' The pl become the ball owner
        exit sub
    case bhv_tile(tile, 6)+1 to bhv_tile(tile, 7)'7: run_to_net
        SHELL_message =  str(decision) + " - TILE " + str(tile) + " R U N to net"
        
        reset_ball_z()
        
        ' 1 xor 1 = 0 so 0*PITCH_W = 0 else 1*PITCH_W = PITCH_W
        ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,_
        PITCH_X + (PITCH_W * (pl(pl_id).team xor 1)), PITCH_MIDDLE_H) + rnd * .5 -.25
        ball.speed = pl(pl_id).speed + rnd*5 + 1
        PL_target_id = -1 ' The pl is not passing to anyone
        PL_ball_owner_id = pl_id ' The pl become the ball owner
        exit sub
    case bhv_tile(tile, 7)+1 to bhv_tile(tile, 8)'8: run_to_endline
        SHELL_message =  str(decision) + " - TILE " + str(tile) + " R U N to endline"
        
        ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,_
        PITCH_X + (PITCH_W * (pl(pl_id).team xor 1)), pl(pl_id).y+1) + rnd * .5 -.25
        ball.speed = pl(pl_id).speed + rnd*5 + 1
        PL_target_id = -1 ' The pl is not passing to anyone
        PL_ball_owner_id = pl_id ' The pl become the ball owner
        
        'debug
        
        exit sub
    case bhv_tile(tile, 8)+1 to 100             '9: shoot_in_target
        SHELL_message =  str(decision) + " - TILE " + str(tile) + " SHOOT in TARGET"
        
        ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,_
        PITCH_X + (PITCH_W * (pl(pl_id).team xor 1)), PITCH_MIDDLE_H) + rnd * .5 -.25
        
        if decision mod 2 = 0 then 
            ball.speed = 5*rnd+10
            ball.z_speed_init = rnd*5+9 : ball.z_speed=ball.z_speed_init
        else
            reset_ball_z()
            ball.speed = 2*rnd+18
            ball.z_speed_init = 10 : ball.z_speed=ball.z_speed_init
        end if
        
        
        PL_target_id = -1 ' The pl is not passing to anyone
        PL_ball_owner_id = pl_id ' The pl become the ball owner
        exit sub
    case else
        SHELL_message =  str(decision) + " - TILE " + str(tile) + " *** SORRY <undefined>"
        exit sub
        
    end select
    
END SUB

SUB reset_ball_z()
    ball.z = 0
    ball.z_speed = 0
    ball.z_speed_init = 0
END SUB

SUB check_pl_collisions()
    Dim c as Ubyte 
    Dim d as Ubyte
    'check each pl
    for c = 0 to (N_TOT_PL*2-1)
        'check collision only if the interested pllayers are int the crop view
        if is_in_camera_crop (pl(c).x, pl(c).y, 64) then
            for d  = 0 to (N_TOT_PL*2-1)
                if d = c or pl(d).active = 0 then continue for 'doesn't check himself obviously :)
                if d_b_t_p (pl(c).x, pl(c).y,pl(d).x, pl(d).y) < PL_MIN_DIST then
                    'some fighting betweeen two players
                    pl(d).x = pl(d).old_x + PL_MIN_DIST/2 - (rnd*PL_MIN_DIST)
                    pl(d).y = pl(d).old_y + PL_MIN_DIST/2 - (rnd*PL_MIN_DIST)
                    'pl(c).x = pl(c).old_x + PL_MIN_DIST/2 - (rnd*PL_MIN_DIST)
                    'pl(c).y = pl(c).old_y + PL_MIN_DIST/2 - (rnd*PL_MIN_DIST)
                    
                    'one of the may fall if the d pl is sliding
                    if int(rnd*10) > 3 and pl(d).action = 3 then
                        pl(c).active = 0
                        pl(c).action = 4
                        pl(c).delay = PL_DELAY_FALLING
                        pl(d).action = 1
                        continue for, for
                    end if
                    'also with running fighting one of the pl may fall
                    if int(rnd*10) > 9 then
                        pl(c).active = 0
                        pl(c).action = 4
                        pl(c).delay = PL_DELAY_FALLING
                        continue for, for
                    end if
                    continue for, for
                end if
            next d
        end if
    next c
    
END SUB

SUB draw_bottom_info()
    dim d as Byte
    
    for d = 0 to int (SCREEN_W / 32) +1 
        PUT (32*d, SCREEN_H-32), shadowed_sprite, trans
    next
    
    Draw String (20,SCREEN_H - 20), str(goal_team_0) + "-" + str(goal_team_1)
    Draw string (64,SCREEN_H - 20), SHELL_message, RGB(200,200,200)
END SUB

function d_t_r (degree as integer) as single
    return int (degree * PI/180)
end function

function r_t_d (radiants as integer) as integer
    return int ((radiants * 360) / (PI*2))
end function

function a_b_t_p (x1 as single, y1 as single, x2 as single, y2 as single) as single
    if (x1>x2) then
        if (y1>y2) then
            return asin ((x1-x2)/sqr(((x1-x2)^2)+((y1-y2)^2))) + PI/2
        else
            return (2 * PI/4)*3 - asin ((x1-x2)/sqr(((x1-x2)^2)+((y1-y2)^2)))  
        end if
    else
        if (y1>y2) then
            return PI/2 - asin ((x2-x1)/sqr(((x1-x2)^2)+((y1-y2)^2)))
        else
            return (2 * PI/4)*3  - asin ((x1-x2)/sqr(((x1-x2)^2)+((y1-y2)^2)))
        end if
    end if
end function

function d_b_t_p (x1 as single, y1 as single, x2 as single, y2 as single) as single
    return sqr(((x1-x2)^2)+((y1-y2)^2))
end function

function start_frame (radiants as single) as integer
    dim degree as Short
    'convert radiants to degree - not calling the function, it is much faster
    degree = int((radiants * 360) / (2*PI))
    select case degree
    case 0 to 22
        return 0
    case 23 to 67
        return 14
    case 68 to 112
        return 28
    case 113 to 157
        return 42
    case 158 to 202
        return 56
    case 203 to 247
        return 70
    case 248 to 292
        return 84
    case 292 to 337
        return 98
    case 337 to 360
        return 0
    case else
        return 14
    end select
end function

function get_tact_tile (pl_id as Ubyte) as Ubyte
    '    'this routine find were the ball is and return the tile where the player must go
    dim tile as Ubyte 
    dim number as Ubyte
    
    tile = tct_tile(pl(pl_id).number-2, get_ball_tile(pl(pl_id).team))
    
    if pl(pl_id).team = 0 then 
        return tile
    else
        return TILES_N_TOT - tile
    end if 
    
end function

function  get_rds_from_tile(tile as Ubyte, pl_x as single, pl_y as single) as single
    dim as integer tile_row, tile_col, x_trg, y_trg
    
    tile_row = tile MOD COL_TOT_N
    tile_col = int(tile/COL_TOT_N)
    
    x_trg = (tile_col * PITCH_W/COL_TOT_N) + PITCH_X + (PITCH_W/COL_TOT_N)/2
    y_trg = PITCH_H - (tile_row * PITCH_H/ROW_TOT_N) + PITCH_Y - (PITCH_H/ROW_TOT_N)/2
    
    'just to don't allow the player to disappear
    if x_trg > PITCH_X + PITCH_W or y_trg > PITCH_Y + PITCH_H then
        x_trg = PITCH_X + PITCH_W /2
        y_trg = PITCH_Y + PITCH_H /2
    end if
    
    return a_b_t_p (pl_x,pl_y,x_trg,y_trg)   
end function

function get_dist_from_tile(tile as Ubyte, pl_x as single, pl_y as single) as single
    dim as integer tile_row, tile_col, x_trg, y_trg
    
    tile_row = tile MOD COL_TOT_N
    tile_col = int(tile/COL_TOT_N)
    
    x_trg = (tile_col * PITCH_W/COL_TOT_N) + PITCH_X + (PITCH_W/COL_TOT_N)/2
    y_trg = PITCH_H - (tile_row * PITCH_H/ROW_TOT_N) + PITCH_Y - (PITCH_H/ROW_TOT_N)/2
    
    return d_b_t_p (pl_x,pl_y,x_trg,y_trg)
    
end function

function get_nrst_pl_ball(n_team as Ubyte) as Ubyte
    dim max_dist as integer = 10000
    dim c as Ubyte
    dim id as Ubyte
    
    'start from id 2 or 3 to don't inlude goalkeepers
    if n_team = 0 then
        for c = 2 to N_TOT_PL * 2-1 step 2
            if d_b_t_p(pl(c).x,pl(c).y,ball.x,ball.y) < max_dist and pl(c).active = 1 then
                max_dist = d_b_t_p(pl(c).x,pl(c).y,ball.x,ball.y)
                id = c
            end if
        next c
        
        return id
    else
        for c = 3 to N_TOT_PL * 2-1 step 2
            if d_b_t_p(pl(c).x,pl(c).y,ball.x,ball.y) < max_dist and pl(c).active = 1 then
                max_dist = d_b_t_p(pl(c).x,pl(c).y,ball.x,ball.y)
                id = c
            end if
        next c
        
        return id
    end if
end function

function get_nrst_pl_pass(pl_id as Ubyte) as Ubyte
    dim max_dist as integer = 10000
    dim as Ubyte c, id, n_team
    n_team = pl(pl_id).team
    for c = 0 to N_TOT_PL * 2-1
        if c = pl_id or pl(c).team <> n_team then continue for 'don't pass himself ot to a player of the other team
        if d_b_t_p(pl(c).x,pl(c).y,pl(pl_id).x,pl(pl_id).y) < max_dist then
            max_dist = d_b_t_p(pl(c).x,pl(c).y,pl(pl_id).x,pl(pl_id).y)
            id = c
        end if
    next c
    
    return id
end function

function get_longside_pl_to_pass (pl_id as Ubyte) as Ubyte
    
    dim a(N_TOT_PL,2) as integer
    dim as Ubyte tile, c, id
    dim max_dist as integer = 10000
    'gets the ball's tile and search the nearest pl to pass who is in the horizontal next tile 
    tile = get_ball_tile(pl(pl_id).team)
    if tile <=29 then
        tile += COL_TOT_N
    end if
    
    if pl(pl_id).team <> 0 then tile = TILES_N_TOT - tile
    
    for c = 0 to N_TOT_PL * 2-1
        if c = pl_id or pl(c).team <> pl(pl_id).team then continue for 'don't pass himself or to a player of the other team
        if get_dist_from_tile(tile, pl(c).x, pl(c).y) < max_dist then
            max_dist = get_dist_from_tile(tile, pl(c).x, pl(c).y)
            id = c
        end if
    next c
    
    return id
    
end function

function get_shortside_pl_to_pass (pl_id as Ubyte) as Ubyte
    
    dim a(N_TOT_PL,2) as integer
    dim as Ubyte tile, c, id
    dim max_dist as integer = 10000
    '    'gets the ball's y and search the nearest pl to pass who is in the vert next tile 
    '
    for c = 0 to N_TOT_PL * 2-1
        'don't pass himself or to a player of the other team
        if c = pl_id or pl(c).team <> pl(pl_id).team then continue for 
        if d_b_t_p(pl(c).x,pl(c).y,pl(pl_id).x+1,PITCH_MIDDLE_H) < max_dist then
            max_dist = d_b_t_p(pl(c).x,pl(c).y,pl(pl_id).x+1,PITCH_MIDDLE_H)
            id = c
        end if
    next c
    
    return id
    
end function


function get_nrst2_pl_pass(pl_id as Ubyte, order as Ubyte) as Ubyte
    
    dim a(N_TOT_PL,2) as integer
    dim as Ubyte b, c, lowest, start, change
    dim as integer ref
    b = 0
    'list all the pl's distances from the pl_id pl
    for c = 0 to N_TOT_PL * 2-1
        if c = pl_id or pl(c).team <> pl(pl_id).team then continue for 'don't pass himself
        a(b,0)=c
        a(b,1)= d_b_t_p (pl(c).x,pl(c).y,pl(pl_id).x,pl(pl_id).y)
        
        b += 1
    next c
    'sort'em using selection sorting algorithm
    for start = 0 to 9
        ref = a(start,1)
        change = 0 
        for b = start+1 to 9
            if a(b,1) < ref then
                ref = a(b, 1)
                lowest = b
                change = 1
            end if
        next b
        if change then
            swap a(lowest, 0), a(start, 0)
            swap a(lowest, 1), a(start, 1)
        end if
    next start
    
    return a(order, 0)
    
end function

function get_farrest_pl_to_pass(pl_id as Ubyte) as Ubyte
    dim min_dist as integer = 1
    dim as Ubyte c, id, n_team
    n_team = pl(pl_id).team
    for c = 0 to N_TOT_PL * 2-1
        if c = pl_id or pl(c).team <> n_team then continue for 'don't pass himself
        if d_b_t_p(pl(c).x,pl(c).y,pl(pl_id).x,pl(pl_id).y) > min_dist then
            min_dist = d_b_t_p(pl(c).x,pl(c).y,pl(pl_id).x,pl(pl_id).y)
            id = c
        end if
    next c
    
    return id
end function

function get_centerest_pl_to_pass(pl_id as Ubyte) as Ubyte
    dim max_dist as integer = 10000
    dim as Ubyte c, id
    
    for c = 0 to N_TOT_PL * 2-1
        if c = pl_id or pl(c).team <> pl(pl_id).team then continue for 'don't pass himself
        if d_b_t_p(PITCH_MIDDLE_W,PITCH_MIDDLE_H,pl(c).x,pl(c).y) < max_dist then
            max_dist = d_b_t_p(PITCH_MIDDLE_W,PITCH_MIDDLE_H,pl(c).x,pl(c).y)
            id = c
        end if
    next c
    
    return id
end function

function get_endline_pl_to_pass(pl_id as integer) as Ubyte
    dim max_dist as integer = 10000
    dim as Ubyte c, id, n_team
    n_team = pl(pl_id).team
    for c = 0 to N_TOT_PL * 2-1
        if c = pl_id then continue for 'don't pass himself
        if n_team <> pl(c).team then continue for 'don't pass to a player of other team
        if n_team = 1 then 
            if pl(c).x - (PITCH_X) < max_dist then
                max_dist = pl(c).x - (PITCH_X)
                id = c
            end if
        else
            if  max_dist > (PITCH_X + PITCH_W) - pl(c).x then
                max_dist = (PITCH_X + PITCH_W) - pl(c).x
                id = c
            end if
        end if
    next c
    
    return id
end function

function get_ball_tile(team as Ubyte) as Ubyte
    dim as byte col, row, tile
    dim as integer x, y, x2,y2
    tile = 0
    'this routine find in which tile is the ball
    for row = 0 to ROW_TOT_N - 1 step 1
        for col = COL_TOT_N - 1 to 0 step -1
            'draw the grid
            x = row * PITCH_W / ROW_TOT_N + PITCH_X 
            y = col * PITCH_H / COL_TOT_N + PITCH_Y
            x2 = x + PITCH_W / ROW_TOT_N
            y2 = y + PITCH_H / COL_TOT_N
            'check if the ball is into a tile of the grid
            if (ball.x > x) and (ball.x < x2) and (ball.y > y) and (ball.y < y2) then
                exit for, for
            end if
            tile +=1
        next col
    next row
    
    if team = 0 then    
        return tile  
    else
        return TILES_N_TOT - tile
    end if
end function

function get_passing_ball_speed (dist as Single) as Single
    dim speed as Single
    select case int(dist)
    case 0 to 10
        speed = 5.5
    case 11 to 30
        speed = 8
    case 31 to 60
        speed = 12
    case 61 to 100
        speed = 18
    case else
        speed = 25
    end select
    return speed
end function

function is_in_camera_crop (x as single, y as single, diam as integer) as Ubyte
    if (x > camera.x - camera.w/2 - diam and x < (camera.x + camera.w/2 + diam))_
    and (y > camera.y - camera.y/2 - diam and y < (camera.y + camera.h/2 + diam)) then
    return 1
else
    return 0
end if
end function


'GFX INIT--------------------------------------------------------------------------------
ScreenRes SCREEN_W,SCREEN_H,24,2,0 ' Sets the graphic mode
SCREENSET 1, 0
CLS
WindowTitle GAME_NAME + " " + Str(GAME_VERSION) + " by " + str(GAME_AUTHOR)
'MAIN------------------------------------------------------------------------------------
load_tact()
load_behavior()
init_players_proprietes()
load_bitmap()
paint_kits(COLOR_ORANGE, COLOR_DARK_RED, COLOR_BLACK, COLOR_PURPLE )
ball_put_on_centre()
DO
    If InKey = Chr(255,107) Then Exit Do 'if the user clicks the X button on the window then ... bye bye JASC
    get_user_input()
    check_pl_collisions()
    update_players()
    update_ball()
    ball_border_pitch_limit_check()
    camera_update_position()
    
    if PL_ball_owner_id >= 0 then
        PL_ball_owner_delay -= 1
        if PL_ball_owner_delay <= 0 then
            PL_ball_owner_delay = PL_DELAY_TIME*2
            PL_ball_owner_id = -1
        end if
    end if
    
    'graphic output
    screenlock ' Lock the screen
    screenset workpage, workpage xor 1 ' Swap work pages.
    cls
    
    draw_pitch()
    draw_nets()
    
    if (DEBUG) then
        'draw_grid()
        '        dim d as Ubyte
        '        dim a as Ubyte
        '        dim temp_String as String
        
        draw_grid()
        
        '        print "Goal 0: "; goal_team_0,"Goal 1: ";goal_team_1
        print "ball tile 0: "; get_ball_tile(0)
        print "ball tile 1: "; get_ball_tile(1)
        '        print "nearest team 0 id:"; get_nrst_pl_ball(0); " nr "; pl(get_nrst_pl_ball(0)).number, _
        '        "nearest team 1 id:"; get_nrst_pl_ball(1); " nr "; pl(get_nrst_pl_ball(1)).number
        '        
        print "ball.x  ball.y  speed rds z"
        print using "####.##"; ball.x, ball.y, ball.speed, ball.rds, ball.z
        
        '        print "     id   number    x     y    speed  rds delay  isincrop"
        '        
        '        for d = 0 to N_TOT_PL * 2 - 1
        '            print using "####.##"; pl(d).id, pl(d).number, pl(d).x, pl(d).y, pl(d).speed,_
        '            pl(d).rds;pl(d).delay; is_in_camera_crop(pl(d).x, pl(d).y, 10),_
        '            get_tact_tile(d)
        '        next d
        '        print "PL_target_id ";PL_target_id
        '        print "PL_ball_owner_id ";PL_ball_owner_id
        '        print "MATCH_event ";MATCH_event
        '        'Debug
        '        for d = 0 to 9
        '            temp_string = ""
        '            for a = 0 to 35
        '                temp_string += str(tct_tile(d,a))
        '            next a
        '            draw string (0, 300 + (d*10)), temp_string
        '        next d
        
    end if
    
    draw_players()
    draw_ball()
    draw_bottom_info()
    
    workpage xor = 1 ' Swap work pages.
    screensync 'wait for vsync
    screenunlock ' Unlock the page to display what has been drawn on the screen
    
    SLEEP SLEEP_TIME, 1 ' Slow down the program to prevent CPU overheating :)
    
LOOP UNTIL MULTIKEY(SC_Q) OR MULTIKEY(SC_ESCAPE)

delete_bitmap()

END
